package cn.com.infosec.ocsp;

import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.asn1.ocsp.ResponderID;
import cn.com.infosec.asn1.x509.SubjectPublicKeyInfo;
import cn.com.infosec.jce.X509Principal;
import java.io.IOException;
import java.security.MessageDigest;
import java.security.PublicKey;
import javax.security.auth.x500.X500Principal;

public class RespID {
   ResponderID id;

   public RespID(ResponderID id) {
      this.id = id;
   }

   public RespID(X500Principal name) {
      RespID var10000 = this;
      super();

      try {
         var10000.id = new ResponderID(new X509Principal(name.getEncoded()));
      } catch (IOException var2) {
         throw new IllegalArgumentException("can't decode name.");
      }
   }

   public RespID(PublicKey key) {
      RespID var10000 = this;
      super();

      Exception var8;
      label33: {
         MessageDigest var9;
         boolean var10001;
         try {
            var9 = MessageDigest.getInstance("SHA1");
         } catch (Exception var4) {
            var8 = var4;
            var10001 = false;
            break label33;
         }

         MessageDigest var5 = var9;

         DEROctetString var10;
         try {
            var9.update(SubjectPublicKeyInfo.getInstance((new ASN1InputStream(key.getEncoded())).readObject()).getPublicKeyData().getBytes());
            var10 = new DEROctetString;
         } catch (Exception var3) {
            var8 = var3;
            var10001 = false;
            break label33;
         }

         DEROctetString key1 = var10;

         try {
            var10.<init>(var5.digest());
            var10000.id = new ResponderID(key1);
            return;
         } catch (Exception var2) {
            var8 = var2;
            var10001 = false;
         }
      }

      Exception var6 = var8;
      throw new OCSPException("problem creating ID: " + var6, var6);
   }

   public ResponderID toASN1Object() {
      return this.id;
   }

   public boolean equals(Object o) {
      if (!(o instanceof RespID)) {
         return false;
      } else {
         RespID var10000 = this;
         RespID var2 = (RespID)o;
         return var10000.id.equals(var2.id);
      }
   }

   public int hashCode() {
      return this.id.hashCode();
   }
}
